var gPhoto;
var gSelectedApi;
var gPhotoMgrSvc;
var gTarget;
var gApiListener;

function init() {
    // need to wrap in an array :/
    var uploadItems = Array();
    gPhoto = window.arguments[0].aPhoto;
    uploadItems.push(gPhoto);
    photoProperties.setUploadType(UPLOAD_TYPE_DND);
    photoProperties.setSelection(uploadItems);
    gTarget = window.arguments[0].aTarget;
    gPhotoMgrSvc = Components.classes['@flock.com/photo-api-manager;1?'] .getService(Components.interfaces.flockIPhotoAPIManager);
    gApiListener = {
        onAPIStateChange: function(aAPI) {
            flock.photo.util.populateServicesPopup($('servicesMenuList').firstChild);
        }
    }
    gPhotoMgrSvc.addListener(gApiListener);
}

function unload() {
    gPhotoMgrSvc.removeListener(gApiListener);
}

function flock_updateSelectedAPI() {
    var selectedApi = $("flockPhotoservicesList").value;
    if (selectedApi) {
        gSelectedApi = gPhotoMgrSvc.getAPIFromShortname($("flockPhotoservicesList").value);
        $('bcasterServiceUploadSelected').removeAttribute('disabled');
        flock_updatePhotoOptionFields();
    } else {
        $('bcasterServiceUploadSelected').setAttribute('disabled', true);
    }
}

function flock_updatePhotoOptionFields() {
    flock_setupPhotoPropsUIFields(gSelectedApi);
}

function flock_launchSingleUpload() {
    var service = gPhotoMgrSvc.getDefaultService();
    if (!service.isLoggedIn) {
     var loginListener = {
            onAuth: function() {
                if (gPhotoMgrSvc.getDefaultService().isLoggedIn) {
                    flock_launchUploadOptions();
                } 
            },
            
            onError: function(aError) {
            },
        }
       var message =  "Flock is opening " + service.serviceName + "'s Sign In page. Follow " + 
                        service.serviceName + "'s instructions to sign in.";
       message += "\n";
       message += "Be sure to close the " + service.serviceName  + " page when you are signed in.";
       alert(message);
       
       // there is a bug in the apimanager which causes multiple state changes
       // which prevents us to use it -- for now call the login on the photoservice directly
       service.login(loginListener);
    } else {
        flock_launchUploadOptions();
    }
}

function flock_launchUploadOptions() {
    var params = {};
    var photoUploads = Array();

    photoUploads.push(window.arguments[0].aPhoto);
    params.photoUploads = photoUploads;
    params.aPhoto = window.arguments[0].aPhoto;
    params.aTarget = gTarget;
    params.numUploads = 1;
    var rv = window.openDialog("chrome://browser/content/flock/photo/flockPhotoUploadOptions.xul", "_blank", "modal,centerscreen", params);
    if (rv && params.launchUploader == true) {
     gPhoto.album = params.albumId;
     photoProperties.synch();
     flock_doSingleUpload();   
    } else {
    return false;    
   }
}

function flock_doSingleUpload() {
    var rval = {};
    var api = gPhotoMgrSvc.getDefaultService();
    window.openDialog("chrome://browser/content/flock/photo/uploadingSinglePhoto.xul", "UploadingSinglePhoto", "modal, centerscreen", api, gPhoto, rval);
    var photo = rval.photo;
    //todo: consolidate this code and with the other photo html stuff
    var html = "<a href=\"" + photo.webPageUrl + "\" > <img src=\"" + photo.largeSizePhoto + "\"/>" + "</a>";
    gTarget.value = gTarget.value + html;
//    window.setTimeout("close();", 0);
    window.close();
    window.blur();
    return;
    var uploadListener = {
        onUploadComplete: function(aUpload) {
        },
        onUploadFinalized: function(aUpload, aPhoto) {
            $('flockQuickUploadStatus').setAttribute('value', 'Your photo was successfully uploaded.. BLAH BLAH');
            $('flock-quickuploader-progress').setAttribute('collapsed', true);
            $('flock-quick-upload-finish').removeAttribute('hidden');
        },
        onError: function(aError) {
            alert("There was an error uploading your photos.  Please try again later.");
        },
    }
    var svcinst = flock.photouploader.service;
    svcinst.singleUpload(uploadListener, gSelectedApi, gPhoto);
}
