// vim: foldmethod=marker

// expects blogCommon, blogSettings, mozExtras to be around... 

var gBlogMenuController = new CommandController({
    mEmptyItem: null,
    cmd_flock_blogBlogThis: flock_blogBlogThisCommand,
    cmd_flock_blogNewPost: flock_blogNewPostCommand,
    cmd_flock_blogOpenPost: flock_blogOpenPostCommand,
    redrawMenu: function () {
        if (flock.blog.service.recentIsEmpty()) {
            flock.xul.show(this.mEmptyItem);
        }
        else {
            flock.xul.hide(this.mEmptyItem);
        }
    },
    onPopupShowing: function (aEvt) {
        this.redrawMenu();
    }
});

function onLoad_blogMenu () {
    gBlogMenuController.mEmptyItem = $('blogEmptyMenuItem');
    window.controllers.appendController(gBlogMenuController);
    gBlogMenuController.redrawMenu();
    
}
dojo.event.connect(window, 'onload', 'onLoad_blogMenu');
